#!/bin/bash

echo -e "\033[1;31mThis software version is outdated and is not recommended for installation."
echo -e "Please use the latest version from the modern branch."
echo -e "It is available for all controller versions.\033[0m"
echo
echo -e "\033[1;31mЭта версия программного обеспечения устарела и не рекомендуется для установки."
echo -e "Рекомендуется использовать последнюю версию из ветки modern."
echo -e "Она доступна для всех версий контроллеров.\033[0m"

exit 1

SELFNAME="$0"
SELFDIR=$(dirname "$SELFNAME")

help () {
    echo
    echo "To install the controller, set the parameters:"
    echo "--no_migrate          Only upgrade mosquitto template. With this parameter, the following arguments will be ignored!!!"
    echo "-m, --move            Only move controller to new server. With this parameter, the following arguments will be ignored!!!"
    echo "-t, --type            TYPE       [ dev | stage | online ]"
    echo "-i, --id              NODE_ID    Some controller id without spaces."
    echo "-u, --mqtt_username   USERNAME   Username on MQTT Server."
    echo "-p, --mqtt_password   PASSWORD   Password on MQTT Server."
    echo
    echo "-e, --extmemory       Use to expand the internal memory. Preinstall a special USB flash drive into the controller!!!"
    echo "-b, --zigbee          Use to support ZigBee."
    echo "-w, --zwave           Use to support Z-Wave."
    echo "--4g                  Use to 4G modem."
    echo "-o, --offline_install DIRECTORY     Use to install IQ packages from local directory."
    echo "-r, --root_password   PASSWORD      Set custom root password."
    echo "--beta                Use BETA Debian-packages."
    echo
}

while [ -n "$1" ]
do
case "$1" in
-t|--type)
    NODE_TYPE="$2"
    shift ;;

-i|--id)
    NODE_ID="$2"
    shift ;;

-u|--mqtt_username)
    LOGIN="$2"
    shift ;;

-p|--mqtt_password)
    PASSWORD=$2
    shift ;;

-o|--offline_install)
    DEB_PACKAGES_DIR=$2
    shift ;;

-w|--zwave)
    ZWAVE=true ;;

-b|--zigbee)
    ZIGBEE=true ;;

-e|--extmemory)
    EXTMEMORY=true ;;

-m|--move)
    ONLY_MOVE=true ;;

--4g)
    FOURTH_GENERATION_MODEM=true ;;

-r|--root_password)
    ROOT_PWD="$2"
    shift ;;

--beta)
    BETA=true ;;

*) help ;;
esac
shift
done

TIMESTAMP=$(date +"%s")

if [ "$ONLY_MOVE" = true ]; then
    ZWAVE=
    ZIGBEE=
    EXTMEMORY=
    DEB_PACKAGES_DIR=

    if [ -z "$NODE_ID" ]; then
        NODE_ID=$(cat /etc/hostname)
    fi
fi

if [ -z "$NODE_TYPE" ] || \
    [ -z "$NODE_ID" ] || \
    [ -z "$LOGIN" ] || \
    [ -z "$PASSWORD" ]; then
    help
    exit 1
fi

if ping ${NODE_TYPE}.iqnergy.com -c 3
then
  echo "Сервер доступен! Продолжаем..."
else
  echo "Ошибка! Сервер недоступен!"
  exit $RES
fi

#######################################
# Переход к архивам stretch
echo 'deb http://archive.debian.org/debian/ stretch main
deb http://archive.debian.org/debian-security/ stretch/updates main' | tee /etc/apt/sources.list.d/debian-upstream.list
echo 'deb http://archive.debian.org/debian/ stretch-backports main' | tee /etc/apt/sources.list.d/stretch-backports.list
rm /etc/apt/sources.list.d/backports.list
#######################################
#######################################

#######################################
# Настройка сетевых адаптеров
if [ -z "$ONLY_MOVE" ]; then
    . /usr/lib/wb-utils/wb_env.sh
    wb_source "of"

    CONFFILE=/etc/wb-hardware.conf

    if of_machine_match "contactless,imx6ul-wirenboard670"; then
      BOARD_CONF="wb67"
    elif of_machine_match "contactless,imx6ul-wirenboard61"; then
      BOARD_CONF="wb61"
    elif of_machine_match "contactless,imx6ul-wirenboard60"; then
      BOARD_CONF="wb60"
    elif of_machine_match "contactless,imx28-wirenboard58"; then
      BOARD_CONF="wb58"
    elif of_machine_match "contactless,imx28-wirenboard55"; then
      BOARD_CONF="wb55"
    elif of_machine_match "contactless,imx28-wirenboard52"; then
      BOARD_CONF="wb52"
    else
      BOARD_CONF="default"
    fi

    if [ -n "$FOURTH_GENERATION_MODEM" ]; then
        apt-get update
        export DEBIAN_FRONTEND=noninteractive
        apt-get install wb-hwconf-manager=1.38.3 -y -o Dpkg::Options::="--force-confdef" -o Dpkg::Options::="--force-confold" --force-yes
        BOARD_CONF="${BOARD_CONF}.4g"
    fi

    PRECONFFILE="${SELFDIR}/wb-hwconf-manager/configs/wb-hardware.conf.${BOARD_CONF}"

    if test -f "$PRECONFFILE"; then
        cp ${PRECONFFILE} ${CONFFILE}
        systemctl restart wb-hwconf-manager
    else
        echo "Controller ${BOARD_CONF} not supported! ${PRECONFFILE} not found!"
        exit 2
    fi
fi
#######################################
#######################################


#######################################
# Обновление systemd для поддержки метрик wb-mqtt-serial
if [ -z "$ONLY_MOVE" ]; then
    echo "deb http://ftp.debian.org/debian stretch-backports main" | tee /etc/apt/sources.list.d/backports.list
    apt-get update -y && apt-get install systemd -t stretch-backports -y || exit $?
fi
#######################################
#######################################


#######################################
# Установка недостающих пакетов и удаление лишних
if [ -z "$ONLY_MOVE" ]; then
apt-get remove wb-mqtt-knx -y

apt-get install -y \
    apt-listchanges \
    rsync \
    wb-mcu-fw-updater \
    resolvconf \
    socat \
    python3 \
    python3-pip \
    apt-transport-https || exit 3
    pip3 install paho-mqtt && pip3 install pyserial || exit 4
fi
#######################################
#######################################


#######################################
# Расширение памяти с помощью флешки
if [ "$EXTMEMORY" = true ]; then
    cat "$SELFDIR/fstab_cfg_extention" >> /etc/fstab
    mount -a
fi
#######################################
#######################################


#######################################
# Установка ПО IQnergy
if [ -z "$ONLY_MOVE" ]; then

    if [ -z "$BETA" ]; then
        echo 'deb https://deb.iqnergy.com/debian/ stretch main' > /etc/apt/sources.list.d/iqnergy.list
    else
        echo 'deb https://deb.iqnergy.com/debian/ stretch beta' > /etc/apt/sources.list.d/iqnergy.list
    fi

    wget -O - http://deb.iqnergy.com/signature.gpg.key | apt-key add - || exit 1
    systemctl restart apt-daily.timer || exit 1
    apt-get -y update

    if [ -z "$DEB_PACKAGES_DIR" ]; then
        apt-get -o Dpkg::Options::="--force-confdef" -o Dpkg::Options::="--force-confold" install -y iq-iqnergy-software-installer || exit 1
    else
        apt-get -o Dpkg::Options::="--force-confdef" -o Dpkg::Options::="--force-confold" install -y "$DEB_PACKAGES_DIR"*deb -y || exit 1
    fi

    # конфигурируем mosquitto
    "$SELFDIR"/configure_mosquitto.sh --mqtt_username ${LOGIN} --mqtt_password ${PASSWORD} --type ${NODE_TYPE} --id ${NODE_ID} || exit 8
    systemctl restart mosquitto || exit 9
fi
#######################################
#######################################


#######################################
# Конфигурирование lsyncd
mkdir -p /etc/lsyncd/
mkdir -p /var/log/lsyncd/

echo -e "$(eval "echo -e \"`cat \"$SELFDIR/lsyncd/lsyncd.conf.lua.template\"`\"")" > "/etc/lsyncd/lsyncd.conf.lua" || exit 17
rsync "$SELFDIR/lsyncd/lsyncd" "/etc/logrotate.d/" || exit 18

if [ -z "$ONLY_MOVE" ]; then
    rm /run/systemd/generator.late/lsyncd.service
    rm /etc/init.d/lsyncd
    cp $SELFDIR/lsyncd/lsyncd.service /lib/systemd/system/
    systemctl daemon-reload && systemctl enable lsyncd
fi

# restart не работает
systemctl stop lsyncd
systemctl start lsyncd || exit 19
#######################################
#######################################


#######################################
# Установка ZigBee
if [ "$ZIGBEE" = true ]; then
    ZIGBEE_DIR=/mnt/data/root/zigbee2mqtt
    apt install -y zigbee2mqtt wb-zigbee2mqtt

    CH=`expr ${NODE_ID:2} % 4`

    case $CH in

      0)
        ZIGBEE_CHANNEL=11
        ;;

      1)
        ZIGBEE_CHANNEL=15
        ;;

      2)
        ZIGBEE_CHANNEL=20
        ;;

      *)
        ZIGBEE_CHANNEL=25
        ;;
    esac


    ZIGBEE_PANID=`expr ${NODE_ID:2} % 16383`
    DEFAULT_ZIGBEE_KEY='DEFAULT!ZigbeeKey'
    ANSII_KEY=`echo $NODE_ID$NODE_ID$DEFAULT_ZIGBEE_KEY | cut -c1-16`
    ANSII_EXT_PANID=`echo $NODE_ID$NODE_ID$DEFAULT_ZIGBEE_KEY | cut -c1-8`
    ZIGBEE_NETWORK_KEY=`printf "$ANSII_KEY" | xxd -p | sed 's/\(..\)/0x&, /g; s/, $//;'`
    ZIGBEE_EXT_PANID=`printf "$ANSII_EXT_PANID" | xxd -p | sed 's/\(..\)/0x&, /g; s/, $//;'`

    echo -e "$(eval "echo -e \"`cat \"$SELFDIR/zigbee/configuration.yaml.template\"`\"")" | tee "$ZIGBEE_DIR/data/configuration.yaml" || exit 20
fi
#######################################
#######################################


#######################################
# Установка Z-Wave
if [ "$ZWAVE" = true ]; then
    apt install -y libarchive13 sharutils gawk libavahi-compat-libdnssd-dev
    wget -c -O /tmp/z-way-3.0.1_armhf.deb https://oldrazberry.z-wave.me/z-way-server/z-way-3.0.1_armhf.deb
    dpkg -i /tmp/z-way-3.0.1_armhf.deb

    echo -e \
    '/var/log/z-way-server.log {
        dateext
        rotate 1
        missingok
        size 500k
        postrotate
            /usr/bin/killall -HUP z-way-server 2>/dev/null || true
        endscript
    }' > /etc/logrotate.d/z-way-server

    chmod 644 /etc/logrotate.d/z-way-server
fi
#######################################
#######################################


#######################################
# Настраиваем watchdog и отключаем web-интерфейс
if [ -z "$ONLY_MOVE" ]; then
    rsync "$SELFDIR/etc/watchdog.conf" /etc/watchdog.conf
    rsync "$SELFDIR/usr/bin/iqnergy/watchdog_io_test.sh" /usr/bin/iqnergy/watchdog_io_test.sh

    systemctl restart watchdog
    systemctl stop nginx
    systemctl disable nginx
fi
#######################################
#######################################


#######################################
# Меняем пароль по-умолчанию на свой
if [ -z "$ONLY_MOVE" ]; then
    echo -e "\nCHANGING ROOT PASSWORD AND ADDING \"$USER_NAME\" USER"
    echo "New password for ROOT"
    echo -e "$ROOT_PWD\n$ROOT_PWD" | passwd || exit 21
fi
#######################################
#######################################


#######################################
# Запоминаем время
if [ -z "$ONLY_MOVE" ]; then
    hwclock --systohc --localtime
fi
#######################################
#######################################

apt-get clean

cat "$SELFDIR/IQ_logo.txt"
sync

YELLOW='\033[1;33m'
GREEN='\033[1;32m'
NC='\033[0m'

printf "${YELLOW}$(cat /etc/hostname): server: $NODE_TYPE"

if [ -n "$FOURTH_GENERATION_MODEM" ]; then
    printf "; 4G"
fi

if [ -n "$ZIGBEE" ]; then
    printf "; ZigBee"
fi

echo

printf "Revision: ${YELLOW}$(timeout 5 mosquitto_sub -t "/devices/system/controls/Batch No" -C 1)${NC}\n"
printf "SN: ${YELLOW}$(timeout 5 mosquitto_sub -t "/devices/system/controls/Short SN" -C 1)${NC}\n"

printf "${GREEN}Install done! ${NC}\n"
